/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package listeners;

import beans.CartBean;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.annotation.WebListener;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

/**
 * Web application lifecycle listener.
 * @author user
 */
@WebListener()
public class SessionListener implements HttpSessionListener {
        CartBean cartBean = lookupCartBeanBean();

    public void sessionCreated(HttpSessionEvent se) {
        se.getSession().setAttribute("cart", cartBean);
    }

    public void sessionDestroyed(HttpSessionEvent se) {

    }

    private CartBean lookupCartBeanBean() {
        try {
            Context c = new InitialContext();
            return (CartBean) c.lookup("java:global/ejb04/CartBean!beans.CartBean");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }
}
